<?php
// PHP script by newquayweather.com
// 
// This script returns yesterdays total sunspots, caches last 30 day data 
// 
// Version 1.00 - 20-Jul-2009 -- Initial release
// Version 1.01 - preg_replace added
// version 1.3 - Minor changes to code
// version 1.4 - Change to file_get_contents
// version 1.5 - Increase timeout time for fetching data to overcome poor connections
// version 1.6 - Minor change
//
// Refresh cached copy of page if needed
//
// Notes, Please read
// This script can be used where yesterdays sunspots number can be displayed
// Example my home page at www.newquayweather.com dashboard, sunspot number
// Change settings to match your server etc and upload
// into a directory named sunspots, 
// Cache file, upload to sunspots directory to, will update with new numbers, adjust $refetchSeconds =3600
// to a lower figure like 10, call script, once updated change back
//
// Can be called by php using
// include("./sunspots/sunspotsyest.php");
// Will display error if file cache file missing or problem downloading ftp file
// End

  $Version = 'sunspot.php V1.6 - 9-April-2017';
  $myTZ = 'Europe/London';  // GMT Time
date_default_timezone_set('Europe/London');
$time_format = 'Hi'; // 0853

  if (!function_exists('date_default_timezone_set')) {
        putenv("TZ=" . $myTZ);
} else {
        date_default_timezone_set("$myTZ");
}
//
// cacheName is name of file used to store cached webpage
// Settings - change to match your server, something like
  $cacheName = "/home/xxxxx/public_html/xxxx/sunspots/cacheyest.txt";  // used to store the file so we don't have to
//                                 fetch every page load
  $refetchSeconds =3600;     // refetch every nnnn seconds 3600 = 1 hour, 7200 = 2 hours etc
// ftp stuff
//$local_file = './cacheyest.txt';
// Do not change $ftp_server url
$ftp_server ='ftp://ftp.swpc.noaa.gov/pub/latest/DSD.txt';

// end settings
// ------ start of code -------

if (file_exists($cacheName) and filemtime($cacheName) + $refetchSeconds > time()) {
      $text = implode('', file($cacheName));
    } else {

$ctx = stream_context_create(array('http' => array('timeout' => 10)));

$text=@file_get_contents($ftp_server, 0, $ctx);

if ($text == "") {
//   throw new Exception("php error message = " . "false");
echo 'Missing cache file or ';
$text=false;
} else {
      $fp = fopen($cacheName, "w");
      if ($fp) {
        $write = fputs($fp, $text);
        fclose($fp);
      } else {
            print "error cant find cache file - $cacheName<br />";
      }
	}
}

if ($text != "") {
$split = preg_split("/[\n]/", $text, -1, 0 );
$lastline = count($split)-2;
$last = $split[$lastline];
$last = preg_replace('/\s\s+/', ' ', $last);
$yest = explode(" ", $last);
$yest_sunspots = $yest[4]; // sunspots
 print ("$yest_sunspots");
} else {
	print "no data<br />";
}

// -------------------------functions ----------------------------------- 
 
 
 

// --------------------end of functions ---------------------------------
?>
